
# Cyber Lizard

## Intro
Want to have a lizard? Here’s your chance to feed a cyber lizard. It accompanies you while browsing, but be careful—it feeds on links. The lizard will sneakily(or not) eat your link and leave the space blank. But don’t worry too much if your links are gone, check the lizard’s stomach to see if they are inside. Of course, you can also put the lizard to sleep if you get tired of its company. Enjoy the fun/trouble brought by your little cyber-pet.

![demo](demo.gif)

## Technical explanation
We use the code shared by the professor to get the exact location of the hovered link for reference and store it once the event mouseover is detected. At the same time, the lizard will appear from the left edge and reach out its tongue towards the link. Once the link is collected, it will disappear immediately by adjusting the visibility in css and a new class will be attached to it to prevent it from being collected again, which is quite important as it will be messy if a link appears multiple times when displaying. By using chrome.sendMassage, the texts and links collected will be sent to the background and stored, where the page of the lizard’s stomach that displays all links can get the local storage and show them. 
The whole process of the lizard eating the links is achieved in the content page. The lizard and its tongue is appended to the original script as two div with background images. The tongue is drawn by hand in photoshop and the lizard image is chosen carefully to look as if it is hunting on the web. The coding involves some math calculations over the distance between two points and the angle that the tongue will rotate. We also applied the transition in css to make the lizard move smoothly. The problem we met at this stage is that we intended to build a lizard that hangs itself beside the extension in a pop-up window. However, we researched a lot on the related APi and found that manifest 3 hasn’t supported resizing window yet, and Chrome is also getting stricter and stricter on viewport altering permissions. Therefore, we made compromise to keep the lizard in the same script with the original page. Due to this problem, the lizard needs to move left and right for presence frequently, and so does the tongue, which made the calculation and timing of the tongue even harder and less accurate. We didn’t realize that it can be a potential problem if the tongue doesn’t start to stretch from the far left. So one improvement we could consider is to make the calculation more accurate.
The lizard’s stomach is created in one button in the popup window and will open another new window, which shows all links that have been eaten. Another button in the popup window will pause the eating process by sending messages back to the content script and changing the boolean value that controls the whole looping statement. There was some trouble because we didn’t find the correct location to put the if statement that checks the boolean, and the pause function didn’t really work properly. But we fixed it later. To make the extension works in all tabs, we have to inject content script into every tab, which is carried out by a new API called chrome.scripting.executeScript. We also need “scripting” in permission to use it. Another thing we need to add in manifest to make the extension work in all tabs is host_permissions": ["<all_urls>"] so that the content script can be effective on all tabs. It took a while to search and figure out how it works, and executescript seems to be a very powerful tool as well.

